// Generated by LiveScript 1.4.0
/**
 * @package   CleverStyle Widgets
 * @author    Nazar Mokrynskyi <nazar@mokrynskyi.com>
 * @copyright Copyright (c) 2015-2016, Nazar Mokrynskyi
 * @license   MIT License, see license.txt
 */
(function(){
  var promise;
  promise = Promise.resolve();
  Polymer.cs.behaviors.csNotify = [
    Polymer.cs.behaviors['this'], {
      properties: {
        bottom: {
          reflectToAttribute: true,
          type: Boolean
        },
        content: String,
        error: {
          reflectToAttribute: true,
          type: Boolean
        },
        left: {
          reflectToAttribute: true,
          type: Boolean
        },
        noIcon: {
          reflectToAttribute: true,
          type: Boolean
        },
        right: {
          reflectToAttribute: true,
          type: Boolean
        },
        show: {
          reflectToAttribute: true,
          type: Boolean
        },
        success: {
          reflectToAttribute: true,
          type: Boolean
        },
        timeout: Number,
        top: {
          reflectToAttribute: true,
          type: Boolean
        },
        warning: {
          reflectToAttribute: true,
          type: Boolean
        }
      },
      listeners: {
        'content.tap': '_tap',
        transitionend: '_transitionend'
      },
      attached: function(){
        var this$ = this;
        this.last_node = this.parentNode;
        if (this.parentNode.tagName !== 'HTML') {
          document.documentElement.appendChild(this);
          return;
        }
        if (!this.bottom && !this.top) {
          this.top = true;
        }
        if (document.readyState !== 'complete') {
          addEventListener('WebComponentsReady', function(){
            setTimeout(bind$(this$, '_schedule_show'));
          });
        } else {
          setTimeout(bind$(this, '_schedule_show'));
        }
      },
      _schedule_show: function(){
        var this$ = this;
        promise = promise.then(function(){
          return new Promise(function(resolve){
            this$.resolve = resolve;
            this$._show();
          });
        });
      },
      _schedule_hide: function(){
        var this$ = this;
        promise = promise.then(function(){
          return new Promise(function(resolve){
            this$.resolve = resolve;
            this$._hide();
          });
        });
      },
      _tap: function(e){
        if (e.target === this.$.content || e.target === this.$.icon) {
          this._schedule_hide();
        }
      },
      _transitionend: function(){
        var ref$;
        if (typeof this.resolve == 'function') {
          this.resolve();
        }
        if (!this.show) {
          if ((ref$ = this.parentNode) != null) {
            ref$.removeChild(this);
          }
          return;
        }
        if (this.timeout) {
          setTimeout(bind$(this, '_schedule_hide'), this.timeout * 1000);
          this.timeout = 0;
        }
      },
      _show: function(){
        var this$ = this;
        if (this.content) {
          this.innerHTML = this.content;
        }
        this._for_similar(function(child){
          var interesting_margin;
          interesting_margin = this$.top ? 'marginTop' : 'marginBottom';
          if (child !== this$ && parseFloat(child.style[interesting_margin] || 0) >= parseFloat(this$.style[interesting_margin] || 0)) {
            child._shift();
          }
        });
        this._initialized = true;
        this.show = true;
        this.fire('show');
      },
      _hide: function(){
        var interesting_margin, this$ = this;
        if (!this.show) {
          return;
        }
        this.show = false;
        interesting_margin = this.top ? 'marginTop' : 'marginBottom';
        this._for_similar(function(child){
          if (parseFloat(child.style[interesting_margin] || 0) > parseFloat(this$.style[interesting_margin] || 0)) {
            child._unshift();
          }
        });
        this.fire('hide');
      },
      _for_similar: function(callback){
        var tagName, bottom, left, right, top, i$, ref$, len$, child;
        tagName = this.tagName;
        bottom = this.bottom;
        left = this.left;
        right = this.right;
        top = this.top;
        for (i$ = 0, len$ = (ref$ = this.parentNode.children).length; i$ < len$; ++i$) {
          child = ref$[i$];
          if (child.show && child.tagName === tagName && child.bottom === bottom && child.left === left && child.right === right && child.top === top) {
            callback(child);
          }
        }
      },
      _shift: function(){
        var style;
        style = getComputedStyle(this);
        if (this.top) {
          this.style.marginTop = parseFloat(style.marginTop) + parseFloat(style.height) + 'px';
        } else {
          this.style.marginBottom = parseFloat(style.marginBottom) + parseFloat(style.height) + 'px';
        }
      },
      _unshift: function(){
        var style;
        style = getComputedStyle(this);
        if (this.top) {
          this.style.marginTop = parseFloat(style.marginTop) - parseFloat(style.height) + 'px';
        } else {
          this.style.marginBottom = parseFloat(style.marginBottom) - parseFloat(style.height) + 'px';
        }
      }
    }
  ];
  function bind$(obj, key, target){
    return function(){ return (target || obj)[key].apply(obj, arguments) };
  }
}).call(this);
